;
;
;	ST-LOW Library
;	(c) 2010 by Simon Sunnyboy / Paradize <marndt@asmsoftware.de>
;	http://paradize.atari.org/
;
;	PC1 file decoder by GT Turbo / Cerebral Vortex
;
;	This library is free software; you can redistribute it and/or
;	modify it under the terms of the GNU Lesser General Public
;	License as published by the Free Software Foundation; either
;	version 2.1 of the License, or (at your option) any later version.
;
;	This library is distributed in the hope that it will be useful,
;	but WITHOUT ANY WARRANTY; without even the implied warranty of
;	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;	Lesser General Public License for more details.
;
;	You should have received a copy of the GNU Lesser General Public
;	License along with this library; if not, write to the Free Software
;	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
;
	EXPORT STLOW_DepackPC1

	SUPER
	TEXT
	; input: a0.l ptr source screen  a1.l ptr destination screen

STLOW_DepackPC1:
		; code by GT Turbo / Cerebral Vortex
		movem.l d0-d7/a0-a6,-(a7)
		
		move.w (a0),(a1)	; copy res
		movem.l 2(a0),d0-d7	; copy palette
		movem.l d0-d7,2(a1)
		lea 34(a1),a1	; point to actual destination picture

		lea 34(a0),a0 ; Debut du pic

		move.w #199,d4 ; 199

All_lines:
		move.l a1,a2 ; Destination
		moveq #3,d1  ; 4 Bit planes

Debut_line:
		move.l a2,a3
		moveq #0,d3
		moveq #1,d5

Recup_code:
		moveq #0,d0
		move.b (a0)+,d0
		bmi.s Repete_code

		add.b d0,d3
		addq.b #1,d3

Copy:
		move.b (a0)+,(a2)
		add.w d5,a2
		eor.w #6,d5

		dbra d0,Copy

		bra.s End_line

Repete_code:
		neg.b d0

		; nop
		addq.b #1,d3
		add.b d0,d3

		move.b (a0)+,d2

Recopy_code:
		move.b d2,(a2)

		add.w d5,a2
		eor.w #6,d5

		dbra d0,Recopy_code

End_line:
		cmp.b #40,d3
		bne.s Recup_code
		move.l a3,a2

		addq.w #2,a2 ; Plan suivant

		dbra d1,Debut_line

		lea 160(a1),a1 ; Ligne suivante
		dbra d4,All_lines

		movem.l (a7)+,d0-d7/a0-a6
		rts 
		END

